#include "Resources.h"
#include "__NetEthInternal_STM32.h"

extern sfr sbit RELAY_1;
extern sfr sbit RELAY_2;

char pageBuffer[8192];
unsigned int pageLength;
char *buffer_ptr;

const code char httpReq_0[] = "HTTP/1.1 200 OK\r\n";
const code char httpReq_1[] = "Content-type: text/html\r\n";
const code char httpReq_2[] = "Cache-Control: no-cache\r\n";
const code char httpReq_3[] = "Connection: close\r\n";
const code char httpReq_4[] = "Keep-Alive: timeout=15, max=100\r\n";
const code char httpReq_5[] = "Accept-Ranges: bytes\r\n";
const code char httpReq_6[] = "Refresh: 10\r\n";
const code char httpReq_7[] = "Content-Length: 1133r\n";
const code char httpReq_8[] = "<!doctype html>\r\n";
const code char httpReq_9[] = "Content-type: text/plain\r\n";
const code char httpReq_10[] = "Server: Mini Web Server/V100\r\n";

extern SOCKET_Intern_Dsc *mySocket;
extern float hdc1000_temp;
extern float hdc1000_humidity;
extern float dewpoint;
extern float airq_ppm;
extern float co_ppm;
extern float light_intensity;
extern unsigned long visit_cnt;
extern unsigned int motion_cnt;
char txt[32];


static void putStringToDynBuffer(char *String) {
   unsigned int data_len;
   char *str_ptr;
   data_len = strlen(String);
   str_ptr = String;
   while (data_len){
    *buffer_ptr++ = *str_ptr;
     str_ptr++;
     pageLength++;
     data_len--;
   }
}


void Create_IndexPage() {
  pageLength = 0;
  buffer_ptr = pageBuffer;
  putStringToDynBuffer(httpReq_0);
  putStringToDynBuffer(httpReq_1);
  putStringToDynBuffer("\r\n\r\n");
  putStringToDynBuffer("<script>");
  putStringToDynBuffer("var counter=");
  LongWordToStr(visit_cnt,txt);
  putStringToDynBuffer(txt);
  putStringToDynBuffer(";");
  putStringToDynBuffer("</script>");
  putStringToDynBuffer(page_index);
}

//SENSORS
void Create_Page1() {
  pageLength = 0;
  buffer_ptr = pageBuffer;
  putStringToDynBuffer(httpReq_0);
  putStringToDynBuffer(httpReq_1);
  putStringToDynBuffer(httpReq_6); //refresh page every 10 sec
  putStringToDynBuffer("\r\n\r\n");
  putStringToDynBuffer("<script>");
  //Temperature
  putStringToDynBuffer("var TEMP=");
  FloatToStr(hdc1000_temp,txt);
  putStringToDynBuffer(txt);
  putStringToDynBuffer(";");
  //Humidity
  putStringToDynBuffer("var HUMIDITY=");
  FloatToStr(hdc1000_humidity,txt);
  putStringToDynBuffer(txt);
  putStringToDynBuffer(";");
  //Dewpoint
  putStringToDynBuffer("var DEWPOINT=");
  FloatToStr(dewpoint,txt);
  putStringToDynBuffer(txt);
  putStringToDynBuffer(";");
  //Light intensity
  putStringToDynBuffer("var LIGHT=");
  FloatToStr(light_intensity,txt);
  putStringToDynBuffer(txt);
  putStringToDynBuffer(";");
  //Air
  putStringToDynBuffer("var AIRQ=");
  FloatToStr(airq_ppm,txt);
  putStringToDynBuffer(txt);
  putStringToDynBuffer(";");
  //Air
  putStringToDynBuffer("var MOT=");
  WordToStr(motion_cnt,txt);
  putStringToDynBuffer(txt);
  putStringToDynBuffer(";");

  putStringToDynBuffer("</script>");
  putStringToDynBuffer(&page_1);
}


//RELAYS
void Create_Page2() {
  pageLength = 0;
  buffer_ptr = pageBuffer;
  putStringToDynBuffer(httpReq_0);
  putStringToDynBuffer(httpReq_1);
  putStringToDynBuffer("\r\n\r\n");
  putStringToDynBuffer("<script>");
  //Relay 1
  if(RELAY_1) {
       putStringToDynBuffer("var R1=1;");
  }else{
       putStringToDynBuffer("var R1=0;");
  }
  //Relay 2
  if(RELAY_2) {
       putStringToDynBuffer("var R2=1;");
  }else{
       putStringToDynBuffer("var R2=0;");
  }
  putStringToDynBuffer("</script>");
  putStringToDynBuffer(&page_2);
}
