#include "__NetEthInternal_STM32.h"
#include "TP_Driver.h"
#include "HTML_Pages.h"
#include "__Time.h"
#define TIMEOUT        6                                                        //update sensors every 6 sec

typedef struct {
  SOCKET_Intern_Dsc *pageSocket;
  char sendState;
  char *currDataPtr;
  char *endDataPtr;
} TPageHandler;



sfr sbit RELAY_1 at GPIOD_ODR.B15;
sfr sbit RELAY_2 at GPIOE_ODR.B6;
sfr sbit MOTION_EN at GPIOE_ODR.B4;
sfr sbit MOTION_OUT at GPIOE_IDR.B1;

//Ethernet
const char   myMacAddr[6] = {0x00, 0x14, 0xA5, 0x76, 0x19, 0x3f} ;              // my MAC address
static unsigned int myPort = 8080;                                              //port

/*for home
const char   myIpAddr[4]  = {192, 168, 1, 16} ;                                  // my IP address
const char   gwIpAddr[4]  = {192, 168, 1, 1 } ;                                 // gateway (router) IP address
const char   ipMask[4]    = {255, 255, 255,  0 } ;                              // network mask (for example : 255.255.255.0)
const char   dnsIpAddr[4] = {192, 168, 1, 1 } ;                                 // DNS server IP address
*/

//mikroe
unsigned char   myIpAddr[4]  = {10, 101, 14, 55 } ;                             // my IP address
unsigned char   gwIpAddr[4]  = {10, 101, 14, 1 } ;                              // gateway (router) IP address
unsigned char   ipMask[4]    = {255, 255, 255,  0 } ;                           // network mask (for example : 255.255.255.0)
unsigned char   dnsIpAddr[4] = {10, 101, 14, 99 } ;                             // DNS server IP address


const char _PHY_BSR = 1;
SOCKET_Intern_Dsc *mySocket;
//no-ip variables
const char   NoIp_Addr[4]  = {8,23,224,120} ;                                   //dynupdate.no-ip.com
char NoIp_mark;
char NoIp_Renew_mark;
char NoIp_Response_mark;
unsigned long reqTimeOut;
//World time server
const char TimeZone_Addr[4]  = {162,220,15,165} ;                               //api.timezonedb.com
//const char TimeZone_Addr[4]  = {192,184,82,62} ;
char TimeZone_mark;
char TimeZone_Request_mark;
char TimeZone_Response_mark;
//Server variables
unsigned long visit_cnt;
int regValue = 0;
char getRequest[1024];
char text[64];
char timeout_cnt;
char Status;

//Motion click
unsigned int motion_cnt;
char motion_old;

//Page handler
const char _PAGE_HANDLER_STATE_IDLE     = 0;
const char _PAGE_HANDLER_STATE_SENDING  = 1;
const char _PAGE_HANDLER_STATE_FINISHED = 2;

const char _WEB_SERVER_STOPPED = 0;
const char _WEB_SERVER_SYNC_DDNS = 1;
const char _WEB_SERVER_SYNC_TIME = 2;
const char _WEB_SERVER_ACTIVE = 3;


TPageHandler pageHandler;
extern char pageBuffer[8192];
extern unsigned int pageLength;

//Methods
const code char httpMethod[] = "GET /";

//Time
//TTime startTime;
//TTime currTime;
TimeStruct Time_t;
long UnixTime;


extern void HDC1000_Setup();
extern void Read_Sensors();

//test
unsigned int test_cnt;
extern const code char iot_image_red1_JPG[14799];